#! /bin/perl

#
# Eric GARREAU, 1997
# BPL (Bob Public License) : register to the Mailing List of this product
# 'Le Petit Bob' at 'egarreau@free.fr'
#

#
# IMPORTANT !
#
# passer le fichier EN ARGUMENT, ne pas utiliser 'stdin' (perl < fichier)
#


#
# Avis au lecteur : merci d'etre indulgent, c'est mon premier jour de Perl...
#

#
# bon, d'accord : ces fichiers ont evolue, depuis mon premier jour de Perl...
#

require 5;


#
# troisieme passe : traiter les directives
#
# TAGS reconnus, et effets
#
# (cf: [nom_fichier][#non]) | <a href="[nom_fichier.html][#nom]">titre</a>
# (inc: nom_image)          | <img src="nom-fichier.gif">  (ou '.jpeg') 
# (inc: img, left)          | <img align="left" ...>
# (inc: img, right)         | <img align="right" ...>
# (inc: img, center)        | <center><img align="middle" ...></center>
# (file: nom_fichier.ext)   | <a href="nom_fichier.ext">nom_fichier.ext</a>
# (file: nom.ext, blabla)   | <a href="nom.ext">blabla</a>
# (dir: nom_repertoire)     | <a href="nom_repertoire/">nom_repertoire</a>
# (dir: rep, blabla)        | <a href="nom_repertoire/">blabla</a>
# (url: url, blabla)        | <a href="url">blabla</a>
# (origin)                  | "<br><i>source : URL du document</i><br>"
# (footer)                  | ajout du fichier 'footer.html.template'
# (contents)       _TODO_   | inserer un sommaire de tous les (sous) titres
# (split)          _TODO_   | eclater le document par chapitres de niveau 1,
#                           |  (ex: doc_1.html, doc_2.html, ...) et ne laisser
#                           |  que le sommaire dans 'doc.html'



use Fcntl;
use ANYDBM_File;;


# la base de l'arborescence Intranet
$TWSROOT=$ENV{'TWSROOT'};
$TWSTOOLS=$ENV{'TWSTOOLS'};
$TWSFILES=$ENV{'TWSFILES'};
die "Variables \$TWS[TOOLS,FILES] non definies --> il faut sourcer '.twsrc'\n" if ($TWSROOT eq '' or $TWSTOOLS eq '' or $TWSFILES eq '');



# niveau de debug, pour les traces 'print XXX if $debug > N'
$pass3Debug=0;



# type de gestion des liens non resolus
#  'MAILTO' : substituer un message "je n'ai pas trouve ce @#^%$ fichier !"
#  'COOL'   : supposer que le fichier demande est dans le repertoire courant
#$error_method = 'MAILTO';
$error_method = 'COOL';


# la "base" des arborescence (un bien grand mot pour un HASH ARRAY...)
$treeshash="$TWSFILES/list_of_trees";



# les HASH ARRAYs, planques dans le repertoire '$TWSFILES'
$linkspathslist="$TWSFILES/list_of_linkspaths";
$linkstitleslist="$TWSFILES/list_of_linkstitles";
$imageslist="$TWSFILES/list_of_images";
$stufflist="$TWSFILES/list_of_stuff";


$footerfile="$TWSTOOLS/footer.html.template";




# le chemin a ajouter pour faire une URL "en absolu"
# (quand on ne peut pas faire du relatif)
###$SERVER_HOST=$ENV{'HOSTNAME'};
$SERVER_HOST='192.9.210.24';

$SERVER_ROOT="http://$SERVER_HOST/";




# si on ne peut pas resoudre un lien, ajouter le nom du fichier a la liste
$errorflag="FALSE";
$errorlist="$TWSFILES/log_unresolved";




# charger les arborescences et les proprietaires
# 0 = pas de masque de creation
tie(%trees, SDBM_File, $treeshash, O_READONLY, 0) or die "(fatal:pass3:$treeshash)\n";

# parcourir toutes les arborescences (tout, puis les '.keep')
foreach $tree (keys(%trees))
{
    my $equiv, $owner;

    ($equiv, $owner) = split(/\n/, $trees{$tree});
    
    if ($equiv ne 'exclude')
    {
	$equivdirs{$tree} = $equiv;
	$treeowners{$tree} = $owner;
    }
}

untie(%trees);



# ou suis-je ? 
$curdir=`/bin/pwd`;
chomp $curdir;


# si on a passe le fichier dans 'stdin', tant pis
if($#ARGV> -1)
{
    # supprimer l'extension du nom du fichier
    $curfile = $ARGV[0];
    $curfile =~ s/\.[^\.]*$//;
    $curfile = "$curdir/$curfile";   # et voila a quoi sert le '$curdir'...
}
else
{
    $curfile='';
};



#
# Ou suis je VRAIMENT ?
# c'est IMPORTANT, pour resoudre les choix multiples et prendre le plus proche
#
# OUI, MAIS... le repertoire courant n'a pas de valeur, car il DOIT etre
#  "relativise" par rapport a la racine du serveur HTTPd

# '$curdir' doit etre termine par un '/'
# (ie : $TWSROOT devient '/' en relatif par rapport a 'http://HOSTNAME/')
$curdir =~ s|/*$|/|;

foreach $absdir (keys(%equivdirs))
{
    # on essaie tout ce qui passe, apres tout...
    last if $curdir =~ s|^$absdir|$equivdirs{$absdir}|;
}

print STDERR "Current dir is [$curdir]\n" if $pass3Debug > 50;




# branchement sur le HASH ARRAY des liens disponibles
# 0 = pas de masque de creation
tie(%linkspaths, SDBM_File, $linkspathslist, O_READONLY, 0) or die "(fatal:pass3:$linkspathslist)\n";
tie(%linkstitles, SDBM_File, $linkstitleslist, O_READONLY, 0) or die "(fatal:pass3:$linkstitleslist)\n";


# branchement sur le HASH ARRAY des images disponibles
# 0x0000 = O_READONLY
# 0 = pas de masque de creation
tie(%images, SDBM_File, $imageslist, 0x0000, 0) or die "(fatal:pass3:$imageslist)\n";


# branchement sur le HASH ARRAY des fichiers disponibles
# 0 = pas de masque de creation
tie(%stuff, SDBM_File, $stufflist, O_READONLY, 0) or die "(fatal:pass3:$stufflist)\n";






# chargement du fichier "pied de page" (ce n'est pas gros, en theorie)
# UN JOUR, ...
# ... probablement, ...
# ... il y aura un test de l'existance de './footerfile' avant de charger
#  betement le 'footer.template'
#
$save_IRS=$/;
undef $/;
open(FOOTER, "< $footerfile");
$footer=<FOOTER>;     # tout le fichier dans '$footer', merci Perl...
close(FOOTER);
$/=$save_IRS;



    

# procedure : GetBestFile
#
# Retourne le MEILLEUR fichier possible, a partir du nom
# du fichier (qui peut contenir des repertoires pour forcer un choix)
# (en plus du fichier, on retourne egalement le titre si il existe)
#
# strategie :
#  - memoriser eventuellement le bout de chemin discriminant, si il existe
#  - demander au HASH tout ce qu'il sait sur ce fichier
#  - une reponse --> royal, et c'est simple
#  - pas de reponse --> pas trouve... mais c'est simple !
#  - plusieurs choix --> hum...
#     - iterer
#        - soustraire le repertoire courant, pour faire apparaitre des
#          chemins plus courts pour les fichiers "en dessous" du
#          repertoire courant
#        - une seule solution --> royal
#        - plusieurs solution a "distance egale" -> le premier gagne
#          (c'est TYPIQUEMENT un cas ou ca vaut le coup de PRECISER un bout
#          du chemin d'acces)
#        - toutes les solutions sont "ailleurs"
#        - faire remonter d'un cran le repertoire courant (imaginez...)
#        - repeter la manip tant qu'on n'est pas arrive a la racine !
#
#
#
sub GetBestFile
{
    my $request, $completerequest, $hashname;
    my $bestlink, $bestindex, $bestlinktitle;
    my $minhops, $minlink;
    my $mydir, $updir;


    ($request, $hashname) = @_;

    # prendre en compte la demande EXPLICITE d'un fichier
    # (un bout de chemin significatif, ca suffit pour discriminer)
    $completerequest = $request;
    if($request =~ m|/|)
    {
	# equivalent a 'awk -F/ '{print $NF}''
	# il DOIT bien y avoir une facon plus ELEGANTE de le faire !...
	@results = split(m|/|, $request);
	$request = pop(@results);   # pour prendre le dernier element
    }
    print STDERR "completerequest=$completerequest, request=$request\n" if $pass3Debug > 14;
    
    # on part du repertoire courant, puis on peut eventuellement "remonter"
    $mydir = $curdir;

    $bestlink = '';
    $bestlinktitle = '';
    $bestindex = -1;

    # y a t il au moins une solution ?
    @links = split(m|\n|, $$hashname{$request});
    $count = @links;

    print STDERR "count=$count, links=[@links]\n" if $pass3Debug > 16;

    # on va abreger les recherches...
    return ('','') if($count == 0);

    # on peut gagner des ms de CPU, mais on perd le chemin 100% relatif...
#     if($count == 1)
#     {
# 	# I love 'pops'
# 	$bestlink = pop(@links);
# 	$bestindex = 0;
#     }
#     else
#    { ...


    # on prepare la grosse artillerie...
    $minhops = 666;
    $minlink = '';
    $updir = '';

    
    # on BOUCLE car on DOIT trouver une solution
    while($bestlink eq '')
    {
	my $index;

	print STDERR "mydir=[$mydir],updir=[$updir]\n" if $pass3Debug > 15;

	# on a besoin de garder l'index pour recuperer le bon titre...
	for($index = 0; $index < $count; $index++)
	{
	    my $link;
	    my $x, $i;

	    $link = $links[$index];

	    print STDERR "index=$index, link=$link\n" if $pass3Debug > 15;

	    # chercher le meilleur uniquement si on est "en dessous"
	    next if ! ($link =~ s|^$mydir||);

	    # on conserve '$link' en relatif par rapport a '$mydir'

	    # eliminier les faux amis si on a un chemin precis
	    $x = $link; $i = 666;
	    print STDERR "relativelink=[$link], x=[$x], nb(/)=[$i]\n" if $pass3Debug > 15;

	    next if ! ($x =~ s|$completerequest||);

	    # compter le nombre de '/' dans le chemin (si il en reste !)
	    for($i = 0; $x =~ m|/|g; $i++) {}
	    
	    print STDERR "relativelink=[$link], x=[$x], nb(/)=[$i]\n" if $pass3Debug > 15;

	    if($i < $minhops)
	    {
		$minhops = $i;
		$bestindex = $index;
		$minlink = $link;
		next;
	    }

# 	    # doit on retourner une erreur en cas d'egalite ????
# 	    if($i == $minhops)
# 	    {
# NON...	$updir = '';
# 		$bestindex = -1;
#               $minlink = '';
# 	    }
	    
	}

	# depouillement des resultats
	if($minhops != 666)
	{
	    # le "meilleur" chemin, en relatif
	    $bestlink = "$updir$minlink";
	}
	else
	{
	    # on essaye de remonter : on DOIT trouver !

	    # si on n'a rien alors que l'on est tout en haut, on a perdu !
	    # il ne faut pas preciser un chemin si on n'en est pas sur, na !
	    if($mydir eq '')
	    {
		print STDERR "[$completerequest] est introuvable, mais [$request] l'est...\n" if $pass3Debug > 15;
		return ('', '');
	    }
	    else
	    {
		# on doit "remonter" d'un cran
		$mydir =~ s|[^/]*/$||;
		$updir = "$updir../";
		
		# tilt en haut de l'arborescence -> on gagne au prochain coup
		# ... en theorie (si 'completeref' n'est pas mauvais)
		if($mydir eq '/')
		{
		    $updir = '/';
		}
	    }
	}
	
    } # on doit sortir avec un '$bestlink'


    # pour le titre, c'est du tout cuit si on a conserve l'index...
    @titles = split(m|\n|, $linkstitles{$request});
    $bestlinktitle = $titles[$bestindex];

    print STDERR "GetBestFile[$bestlink][$bestlinktitle]\n" if $pass3Debug > 12;

    return ($bestlink, $bestlinktitle);
}


#
# procedure : GetBestLink
#
# retourne : un tableau avec deux chaines de caracteres :
#  - une chaine de caracteres pour l'URL (vide si rien n'a ete trouve)
#  - une chaine de caracteres pour le titre
#
sub GetBestLink
{
    my @bestlinktitle;
    my $request;

    ($request) = @_;
    
    @bestlinktitle = GetBestFile($request, 'linkspaths');
    
    return @bestlinktitle;
}

#
# procedure : GetBestImage
#
# retourne : une chaine de caracteres (vide si rien n'a ete trouve)
#
sub GetBestImage
{
    my $bestimage;
    my $void;
    my $request;

    ($request) = @_;
     
    ($bestimage, $void) = GetBestFile($request, 'images');
    
    return $bestimage;
}


#
# procedure : GetBestStuff
#
# retourne : une chaine de caracteres (vide si rien n'a ete trouve)
#
# NOTE : pour autoriser le LIEN sur une image, sans l'inclure systematiquement,
# on teste l'extension "ici", et on dirige la recherche vers 'GetBestImage'
# ou 'GetBestStuff' selon.
sub GetBestStuff
{
    my $beststuff;
    my $void;
    my $request;

    ($request) = @_;

    if(   $request =~ s/\.gif//i 
       or $request =~ s/\.jpg//i
       or $request =~ s/\.jpeg//i)
    {
	($beststuff, $void) = GetBestFile($request, 'images');
    }
    else
    {
	($beststuff, $void) = GetBestFile($request, 'stuff');
    }
    
    return $beststuff;
}





# # XXXXXXXXXXXXXXXXX du debug !
# print "start from here !\n";

# ($x, $y) = GetBestFile('tools/README', 'linkspaths');
# print "x=$x, y=$y\n\n";

# ($x, $y) = GetBestFile('cap/tools/README', 'linkspaths');
# print "x=$x, y=$y\n\n";



# exit;



# transformer le fichier en fichier HTML en branchant les liens
while($_ = <>)
{
    # on force un 'match' bidon pour entrer dans le 'while'
    $matched='true';
    
    # plusieurs substitutions possibles par ligne
    while($matched)
    {
	$matched = ();

	##
	## traitement d'une demande de LIEN hypertexte
	## formats acceptes :
	##   '(cf: lien)'
	##   '(cf: #ancrage)'
	##   '(cf: lien#ancrage)'
	##
	if(/\(cf\s*:\s*([^\,]+)\,\s*([^\(\)]+)\)/ || /\(cf\s*:\s*([^\(\)]+)\)/)
	{
	    $matched = 'true';
	    
	    # demarche optimiste...
	    my $success = 'yes';

	    my $url = $1;

	    # cette variable n'apparait qu'a la fin des test, et elle ecrase
	    # tout ce qui a pu etre trouve automatiquement si elle existe
	    my $comment = $2;

	    print STDERR "url=$url, comment=$comment\n" if $pass3Debug > 14;
	    
	    # separer la partie 'fichier' et la partie 'ancrage'
	    ($file, $anchor) = split('#', $url);
	    print STDERR "file=$file,anchor=$anchor\n" if $pass3Debug > 14;

	    
	    # ne pas chercher le chemin de l'URL si le lien est interne
	    if($file eq '')
	    {
		$link = "\#$anchor";
				
		# le nom de l'ancrage devient logiquement le texte du lien
		$title = $anchor;
	    }
	    else
	    {
		($link, $title) = GetBestLink($file);
		
		# si il y a un ancrage, l'ajouter au titre
		# sauf si le lien n'a pas ete trouve, pour declencher l'erreur
		if($link eq '')
		{
		    $success = 'no';
		    $title = $file;
		}
		else
		{
		    if($anchor ne '')
		    {
			$title = "$title \($anchor\)";
			
			$link = "$link\#$anchor";
		    }
		}
		
		print STDERR "link/tilte=[$link][$title]\n" if $pass3Debug > 13;
	    }


	    # une fois qu'on a les billes, on peut encore TOUT casser...

	    # si il y a un commentaire, ecraser bestialement le reste
	    if($comment ne '')
	    {
		$title = $comment;
	    }


	    if($link ne '')
	    {
		s/\(cf\s*:\s*[^\,\)]+\,[^\)]+\)/<a href="$link">$title<\/a>/ || \
		    s/\(cf\s*:\s*[^\)]+\)/<a href="$link">$title<\/a>/;
	    }
	    else
	    {
		if($error_method eq 'MAILTO')
		{
		    unless ($file =~ /index/)
		    {
			$errorflag = 'TRUE';
			
			s/\(cf\s*:\s*[^\)]+\)/<a href="mailto:root\@bunny.pf"><strong>--> l\'automate n\'a pas reussi a trouver le fichier coorespondant au lien demande : \'$file\'. Cliquez sur ce lien pour signaler ce defaut en envoyant un MAIL a \'root\@bunny\'<\/strong><\/a>/;
		    }
		}
		else
		{
		    # supposer que le fichier se trouve dans CE repertoire,
		    # ce qui permet de faire un fichier "presentable"...
		    $link = "$file.html";
		    
		    if($anchor ne '')
		    {
			$link = "$link\#$anchor";
		    }
		    
		    s/\(cf\s*:\s*[^\,\)]+\,[^\)]+\)/<a href="$link">$title<\/a>/ || \
			s/\(cf\s*:\s*[^\)]+\)/<a href="$link">$title<\/a>/;
		    
		    unless ($file =~ /index/)
		    {
			$errorflag = 'TRUE';
			# pour info...
			push(@unresolved_links, "cf: $file");
		    }
		} # error ne 'MAILTO'
	    } # link is empty
	} # if(cf:)
	
	
	
	##
	## traitement d'une demande d'inclusion d'IMAGE
	## format : '(inc: image[, position]))'
	##   - center : casse le paragraphe et centre l'image
	##   - left : tout le document se debrouille pour contourner a droite
	##   - right : tout le document se debrouille pour contourner a gauche
	##   - (rien) : la ligne de texte qui 'colle' a l'image est centree sur
	##              le milieu de l'image
	##
	if(/\(inc\s*:\s*([^\,]+)\,\s*([^\(\)]+)\)/ || /\(inc\s*:\s*([^\(\)]+)\)/)
	{
	    $matched = 'true';
	    
	    my $file = $1;
	    my $alignment = $2;
	    if($alignment eq '')
	    {
		$alignment = 'bof';
	    }

	    print STDERR "file=$file, alignment=$alignment\n" if $pass3Debug > 12;

	    my $link = GetBestImage($file);


	    # alignements de l'image (ce n'est pas top...)
	    ($c1, $c2, $a)=('', '', 'align=right') if $alignment =~ /right/i;
	    ($c1, $c2, $a)=('', '', 'align=left') if $alignment =~ /left/i;
	    ($c1, $c2, $a)=('<center>', '</center>', 'align=middle') if $alignment =~ /center/i;
	    ($c1, $c2, $a)=('', '', 'align=middle') if $alignment eq 'bof';
	    
	    if($link ne '')
	    {
		s/\(inc\s*:\s*[^\,\)]+\,\s*[^\)]+\)/$c1<img src="$link" alt="$abslink" $a>$c2/ || \
		    s/\(inc\s*:\s*[^\)]+\)/$c1<img src="$link" alt="$abslink" $a>$c2/;
	    }
	    else
	    {
		$errorflag = 'TRUE';

		if($error_method eq 'MAILTO')
		{
		s/\(inc\s*:\s*[^\)]+\)/<a href=\"mailto:root\@bunny.pf\"><strong>--> l\'automate n\'a pas reussi a trouver l\'image demandee : \'$file\'. Cliquez sur ce lien pour signaler ce defaut en envoyant un MAIL a \'root\@bunny\'<\/strong><\/a>/;
		}
		else
		{
		    # supposer que le fichier se trouve dans CE repertoire,
		    # ce qui permet de faire un fichier "presentable"...
		s/\(inc\s*:\s*[^\,\)]+\,\s*[^\)]+\)/$c1<img src="$file.gif" alt="$abslink" $a>$c2/ || \
		    s/\(inc\s*:\s*[^\)]+\)/$c1<img src="$file.gif" alt="$abslink" $a>$c2/;
		    # pour info...
		    push(@unresolved_links, "inc: $file");
		}

	    }
	}



	##
	## traitement d'une demande d'inclusion de fichier non-HTML
	## format : '(file: fichier[, nom en clair])'
	##
	if(/\(file\s*:\s*([^\,\)]+)\,\s*([^\)]+)\)/ || /\(file\s*:\s*([^\)]+)\)/)
	{
	    $matched = 'true';
	
	    my $file = $1;
	    my $comment = $2;
	    if($comment eq '')
	    {
		$comment = $file;
	    }

	    print STDERR "[[$file, comment=$comment]]\n" if $pass3Debug > 11;

	    my $link = GetBestStuff($file);

	    if($link ne '')
	    {
		s/\(file\s*:\s*[^\,\)]+\,\s*[^\)]+\)/<a href="$link">$comment<\/a>/ || \
		    s/\(file\s*:\s*[^\)]+\)/<a href="$link">$comment<\/a>/ ;
	    }
	    else
	    {
		$errorflag = 'TRUE';
		
		if($error_method eq 'MAILTO')
		{
		    s/\(file\s*:\s*[^\)]+\)/<a href="mailto:root\@bunny.pf"><strong>--> l\'automate n\'a pas reussi a trouver le fichier demande : \'$file\'. Cliquez sur ce lien pour signaler ce defaut en envoyant un MAIL a \'root\@bunny\'<\/strong><\/a>/;
		}
		else
		{
		    s/\(file\s*:\s*[^\,\)]+\,\s*[^\)]+\)/<a href="$file">$comment<\/a>/ || \
			s/\(file\s*:\s*[^\)]+\)/<a href="$file">$comment<\/a>/ ;
		    # pour info...
		    push(@unresolved_links, "file: $file");
		}
	    }
	}


	##
	## traitement d'une demande de lien sur un repertoire
	## format : '(dir: repertoire[,nom en clair])'
	##
	if(/\(dir\s*:\s*([^\,\)]+)\,\s*([^\)]+)\)/ || /\(dir\s*:\s*([^\)]+)\)/)
	{
	    $matched = 'true';

	    $file = $1;
	    $comment = $2;
	    print STDERR "file=$file, comment=$comment\n" if $pass3Debug > 10;

	    if($comment eq '')
	    {
		$comment = $file;
	    };

	    # il n'y a pas de test, c'est du vite-fait-mal-fait
	    s/\(dir\s*:\s*[^\,\)]+\,[^\)]+\)/<a href="$file\/">$comment<\/a>/ ||
		s/\(dir\s*:\s*([^\)]+)\)/<a href="$file\/">$comment<\/a>/;
	}

	##
	## traitement d'une demande de lien sur un *vrai* URL
	## format : '(url: url,[blabla])'
	##
	if(/\(url\s*:\s*([^\,\)]+)\,\s*([^\)]+)\)/ || /\(url\s*:\s*([^\)]+)\)/)
	{
	    $matched = 'true';

	    $file = $1;
	    $comment = $2;
	    print STDERR "file=$file, comment=$comment\n" if $pass3Debug > 10;

	    if($comment eq '')
	    {
		$comment = $file;
	    };

	    # il n'y a pas de test, c'est du vite-fait-mal-fait
	    s/\(url\s*:\s*[^\,\)]+\,[^\)]+\)/<a href="$file">$comment<\/a>/ ||
		s/\(url\s*:\s*([^\)]+)\)/<a href="$file">$comment<\/a>/;
	}

	##
	## traitement d'une demande d'affichage du nom de la source
	## format : '(origin[,commentaire])'
	##
	if(/\(origin\,\s*([^\)]+)\)/ || /\(origin\)/)
	{
	    $matched = 'true';

	    if($1 ne '')
	    {
		$comment = "<br>&nbsp $1";
	    }
	    else
	    {
		$comment = '';
	    }

	    # generer l'URL du fichier
	    $x = $curfile;
	    foreach $absdir (keys(%equivdirs))
	    {
		# on essaie tout ce qui passe, apres tout...
		last if $x =~ s|^$absdir|$equivdirs{$absdir}|;
	    }
	    $x = "$SERVER_ROOT$x.html";

	    # faire une belle chaine de caracteres avec la date ISO
	    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
		localtime();
	    
	    # en attendant que 'localtime' retourne une annee sur 4 chiffres...
	    # (si la date passe sur 4 chiffres, ca marchera encore)
	    # vous pensez vraiment que ca peut vivre au dela de l'an 2000 ?
	  CHECKDATE:
	    {
		$year += 2000, last CHECKDATE if $year < 50;
		$year += 1900, last CHECKDATE if $year > 50 and $year < 100;
	    }
	    # pratique, l'acces direct au tableau des mois en clair...
	    $mydate=sprintf("%4d-%s-%02d &nbsp %02d:%02d",
			    $year, 
			    ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec')[$mon],
			    $mday, $hour, $min);
	    
	    s/\(origin[^\)]*\)/<font size=-1><i>source :<br>&nbsp $x<br>&nbsp $mydate$comment<\/i><\/font><br>/;
	}

	##
	## traitement d'une demande de pied de page
	## format : '(footer)'
	##
	if(/\(footer\)/)
	{
	    $matched = 'true';

	    # tout un fichier dans une variable pour se simpifier la vie...
	    s/\(footer\)/$footer/;
	}

    }

    print;
}



if($errorflag eq 'TRUE')
{
    # on ajoute un magnifique '.txt' pour le coupe/colle direct vers emacs...
    $txtfile = "$curfile.txt";

    # 1) ajouter le fichier a la liste
    open(ERRORS,">> $errorlist");
    print ERRORS "$txtfile\n";
    close(ERRORS);

    # 2) faire un 'touch' sur le '.txt', pour qu'il soit plus recent que
    # le '.html', et que le 'Makefile' le harcele a chaque passage (niarque)
    # (admirez le 'sleep' pour avoir le dernier mot sur 'txt2html'...)
    system "(sleep 3;touch $txtfile)&";

    # 3) si on est 'COOL', alors on glisse un petit memo a la fin du fichier,
    # pour indiquer qu'il y a qq chose qui cloche...
    # bon, je sais : c'est APRES le '</BODY></HTML>', et c'est TRES sale...
    if($error_method eq 'COOL')
    {

	print "<br><br><hr><font size=\"-1\"><i>Ce fichier contient au moins une reference hypertexte qui n'a pas pu etre resolue automatiquement par 'txt2html'...<p>";
	while($ref = pop(@unresolved_links))
	{
	    print " ($ref) &nbsp ";
	}
	print "</i></font>";
    }
}

